#include "testlib.h"

using namespace std;

const int INF = 1000;

int MAXNS[] = {  50,   4000,   10,  10,  70,  200,  50, 100};
int MAXMS[] = { 100,    INF,  100, INF, 500, 1000, 100, 100};
int MAXKS[] = {  10,      1,   10,  10,  70,  200,  50, 100};
int MAXTS[] = {   2,      1,    1,   2,   1,   1,    2,   2};

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int gr = 0;
    if (!validator.group().empty()) {
        gr = validator.group()[0] - '0';
    }

    int mt = inf.readInt(1, 1000, "tests");
    inf.readEoln();
    int tot = 0;
    for (int i = 0; i < mt; i++) {
        int n = inf.readInt(1, MAXNS[gr], format("n[%d]", i));
        inf.readSpace();
        int k = inf.readInt(1, min(n - 1, MAXKS[gr]), format("k[%d]", i));
        inf.readSpace();
        int m = inf.readInt(1, MAXMS[gr], format("m[%d]", i));
        inf.readSpace();
        int t = inf.readInt(1, MAXTS[gr], format("t[%d]", i));
        inf.readEoln();
        
        if (gr == 1) {
            ensuref(n <= 4, "n is more than 4");
        }

        string s = inf.readToken("[0-9]+", format("s[%d]", i));
        inf.readEoln();
        ensuref(s.length() == n, "length of s[%d] is %d, not %d", i, (int) s.length(), n);
        tot += n;
    }

    ensuref(tot <= MAXNS[gr], "total size is %d, exceeds %d", tot, MAXNS[gr]);

    inf.readEof();

    return 0;
}
